Index: trunk/modules/vci_mem_cache_v4/caba/source/src/vci_mem_cache_v4.cpp
===================================================================
--- trunk/modules/vci_mem_cache_v4/caba/source/src/vci_mem_cache_v4.cpp	(revision 253)
+++ trunk/modules/vci_mem_cache_v4/caba/source/src/vci_mem_cache_v4.cpp	(revision 273)
@@ -3271,576 +3536,671 @@
     ////////////////////////////////////////////////////////////////////////////////////
 
-
-    switch ( r_cleanup_fsm.read() ) 
+    switch ( r_cleanup_fsm.read() )
     {
-        //////////////////
-        case CLEANUP_IDLE:
-        {
-            if ( p_vci_tgt_cleanup.cmdval.read() ) 
-            {
-                if (p_vci_tgt_cleanup.srcid.read() >= m_initiators )
-                {
-                    std::cout << "VCI_MEM_CACHE ERROR " << name() 
-                              << " CLEANUP_IDLE state" << std::endl;
-                    std::cout << "illegal srcid for  cleanup request" << std::endl;
-                    exit(0);
-                }
-
-                bool reached = false;
-                for ( size_t index = 0 ; index < m_ncseg && !reached ; index++ )
-                {
-                    if ( m_cseg[index]->contains((addr_t)(p_vci_tgt_cleanup.address.read())) )
-                        reached = true;
-                }
-                // only write request to a mapped address that are not broadcast are handled
-                if ( (p_vci_tgt_cleanup.cmd.read() == vci_param::CMD_WRITE) &&
-                     ((p_vci_tgt_cleanup.address.read() & 0x3) == 0) && reached) 
-                {
-                    addr_t line =(((addr_t) p_vci_tgt_cleanup.be.read() << (vci_param::B*8))) |
-                                 (((addr_t) p_vci_tgt_cleanup.wdata.read()));
-
-                    r_cleanup_nline = line;
-                    r_cleanup_srcid = p_vci_tgt_cleanup.srcid.read();
-                    r_cleanup_trdid = p_vci_tgt_cleanup.trdid.read();
-                    r_cleanup_pktid = p_vci_tgt_cleanup.pktid.read();
-                    r_cleanup_fsm   = CLEANUP_DIR_LOCK;
+      //////////////////
+      case CLEANUP_IDLE:
+      {
+        if ( p_vci_tgt_cleanup.cmdval.read() )
+        {
+          if (p_vci_tgt_cleanup.srcid.read() >= m_initiators )
+          {
+            std::cout << "VCI_MEM_CACHE ERROR " << name()
+              << " CLEANUP_IDLE state" << std::endl;
+            std::cout << "illegal srcid for  cleanup request" << std::endl;
+            exit(0);
+          }
+
+          bool reached = false;
+          for ( size_t index = 0 ; index < m_ncseg && !reached ; index++ )
+          {
+            if ( m_cseg[index]->contains((addr_t)(p_vci_tgt_cleanup.address.read())) )
+              reached = true;
+          }
+          // only write request to a mapped address that are not broadcast are handled
+          if (( p_vci_tgt_cleanup.cmd.read() == vci_param::CMD_WRITE ) &&
+              (( p_vci_tgt_cleanup.address.read() & 0x3 ) == 0 ) && reached )
+          {
+            addr_t line =(((addr_t) p_vci_tgt_cleanup.be.read() << (vci_param::B*8))) |
+              (((addr_t) p_vci_tgt_cleanup.wdata.read()));
+
+            r_cleanup_nline = line;
+            r_cleanup_srcid = p_vci_tgt_cleanup.srcid.read();
+            r_cleanup_trdid = p_vci_tgt_cleanup.trdid.read();
+            r_cleanup_pktid = p_vci_tgt_cleanup.pktid.read();
+            r_cleanup_fsm   = CLEANUP_DIR_REQ;
+
+  #if DEBUG_MEMC_CLEANUP
+            if( m_debug_cleanup_fsm )
+            {
+              std::cout << "  <MEMC " << name() << ".CLEANUP_IDLE> Cleanup request:" << std::hex
+                << " line addr = " << line * m_words * 4
+                << " / owner_id = " << p_vci_tgt_cleanup.srcid.read()
+                << " / owner_ins = " << (p_vci_tgt_cleanup.trdid.read()&0x1)
+                << std::endl;
+            }
+  #endif
+            m_cpt_cleanup++;
+          }
+        }
+        break;
+      }
+
+      //////////////////////
+      case CLEANUP_DIR_REQ:
+      // Get the lock to the directory
+      {
+        if ( r_alloc_dir_fsm.read() == ALLOC_DIR_CLEANUP )
+        {
+          r_cleanup_fsm = CLEANUP_DIR_LOCK;
+        }
 
 #if DEBUG_MEMC_CLEANUP
-if( m_debug_cleanup_fsm )
-{
-    std::cout << "  <MEMC " << name() << ".CLEANUP_IDLE> Cleanup request:" << std::hex
-              << " line addr = " << line * m_words * 4
-              << " / owner_id = " << p_vci_tgt_cleanup.srcid.read() 
-              << " / owner_ins = " << (p_vci_tgt_cleanup.trdid.read()&0x1)
-              << std::endl;
-}
-#endif
-                    m_cpt_cleanup++;
-                }
-            }
-            break;
-        }
-        //////////////////////
-        case CLEANUP_DIR_LOCK:	// test directory status
-        {
-            if ( r_alloc_dir_fsm.read() == ALLOC_DIR_CLEANUP ) 
-            {
-                // Read the directory
-                size_t way = 0;
-	            addr_t cleanup_address = r_cleanup_nline.read() * m_words * 4;
-                DirectoryEntry entry   = m_cache_directory.read(cleanup_address , way);
-                r_cleanup_is_cnt       = entry.is_cnt;
-                r_cleanup_dirty	       = entry.dirty;
-                r_cleanup_tag	       = entry.tag;
-                r_cleanup_lock	       = entry.lock;
-                r_cleanup_way	       = way;
-                r_cleanup_copy         = entry.owner.srcid;
+        if( m_debug_cleanup_fsm )
+        {
+          std::cout 
+            << "  <MEMC " << name() << ".CLEANUP_DIR_REQ> Requesting DIR lock "
+            << std::endl;
+        }
+#endif
+        break;
+      }
+
+      //////////////////////
+      case CLEANUP_DIR_LOCK:  // test directory status
+      {
+        if ( r_alloc_dir_fsm.read() == ALLOC_DIR_CLEANUP )
+        {
+          // Read the directory
+          size_t way = 0;
+          addr_t cleanup_address = r_cleanup_nline.read() * m_words * 4;
+          DirectoryEntry entry   = m_cache_directory.read(cleanup_address , way);
+          r_cleanup_is_cnt       = entry.is_cnt;
+          r_cleanup_dirty        = entry.dirty;
+          r_cleanup_tag          = entry.tag;
+          r_cleanup_lock         = entry.lock;
+          r_cleanup_way          = way;
+          r_cleanup_copy         = entry.owner.srcid;
 #if L1_MULTI_CACHE
-                r_cleanup_copy_cache= entry.owner.cache_id;
-#endif
-                r_cleanup_copy_inst    = entry.owner.inst;
-                r_cleanup_count        = entry.count;
-                r_cleanup_ptr          = entry.ptr;
-
-                if( entry.valid) //  hit : the copy must be cleared  
-                {
-                    if ( (entry.count==1) || (entry.is_cnt) )  // no access to the heap
-                    {
-                        r_cleanup_fsm = CLEANUP_DIR_WRITE;
-                    } 
-                    else 					// access to the heap
-                    {
-                        r_cleanup_fsm = CLEANUP_HEAP_LOCK;
-                    }
-                } 
-                else 		// miss : we must check the update table
-                {
-                    r_cleanup_fsm = CLEANUP_UPT_LOCK;
-                }
+          r_cleanup_copy_cache   = entry.owner.cache_id;
+#endif
+          r_cleanup_copy_inst    = entry.owner.inst;
+          r_cleanup_count        = entry.count;
+          r_cleanup_ptr          = entry.ptr;
+
+          if( entry.valid) //  hit : the copy must be cleared
+          {
+            if ( (entry.count==1) || (entry.is_cnt) )  // no access to the heap
+            {
+              r_cleanup_fsm = CLEANUP_DIR_WRITE;
+            }
+            else          // access to the heap
+            {
+              r_cleanup_fsm = CLEANUP_HEAP_REQ;
+            }
+          }
+          else    // miss : we must check the update table
+          {
+            r_cleanup_fsm = CLEANUP_UPT_LOCK;
+          }
 
 #if DEBUG_MEMC_CLEANUP
-if( m_debug_cleanup_fsm )
-{
-    std::cout << "  <MEMC " << name() << ".CLEANUP_DIR_LOCK> Test directory status: " << std::hex
+          if( m_debug_cleanup_fsm )
+          {
+            std::cout
+              << "  <MEMC " << name()
+              << ".CLEANUP_DIR_LOCK> Test directory status: " << std::hex
               << " line = " << r_cleanup_nline.read() * m_words * 4
               << " / hit = " << entry.valid
               << " / dir_id = " << entry.owner.srcid
               << " / dir_ins = " << entry.owner.inst
-              << " / search_id = " << r_cleanup_srcid.read() 
+              << " / search_id = " << r_cleanup_srcid.read()
               << " / search_ins = " << (r_cleanup_trdid.read()&0x1)
               << " / count = " << entry.count
               << " / is_cnt = " << entry.is_cnt << std::endl;
-}
-#endif
-            }
-            break;
-        }
-        ///////////////////////
-        case CLEANUP_DIR_WRITE:  //  update the directory entry without heap access
-        {
-            if ( r_alloc_dir_fsm.read() != ALLOC_DIR_CLEANUP )
-            {
-                std::cout << "VCI_MEM_CACHE ERROR " << name() 
-                          << " CLEANUP_DIR_WRITE state" 
-                          << " bad DIR allocation" << std::endl;
-                exit(0);
-            }
-
-            size_t way         = r_cleanup_way.read();
-            size_t set         = m_y[(vci_addr_t)(r_cleanup_nline.read()*m_words*4)];
-            bool cleanup_inst  = r_cleanup_trdid.read() & 0x1; 
-            bool match_srcid   = ((r_cleanup_copy.read() == r_cleanup_srcid.read())
+          }
+#endif
+        }
+        else
+        {
+          std::cout << "VCI_MEM_CACHE ERROR " << name()
+            << " CLEANUP_DIR_LOCK state"
+            << " bad DIR allocation" << std::endl;
+
+          exit(0);
+        }
+        break;
+      }
+
+      ///////////////////////
+      case CLEANUP_DIR_WRITE:
+      // Update the directory entry without heap access
+      {
+        if ( r_alloc_dir_fsm.read() != ALLOC_DIR_CLEANUP )
+        {
+          std::cout << "VCI_MEM_CACHE ERROR " << name()
+            << " CLEANUP_DIR_WRITE state"
+            << " bad DIR allocation" << std::endl;
+          exit(0);
+        }
+
+        size_t way         = r_cleanup_way.read();
+        size_t set         = m_y[(vci_addr_t)(r_cleanup_nline.read()*m_words*4)];
+        bool cleanup_inst  = r_cleanup_trdid.read() & 0x1;
+        bool match_srcid   = ((r_cleanup_copy.read() == r_cleanup_srcid.read())
 #if L1_MULTI_CACHE
-                                and (r_cleanup_copy_cache.read() == r_cleanup_pktid.read())
-#endif
-                                );
-            bool match_inst    = (r_cleanup_copy_inst.read()  == cleanup_inst);
-            bool match         = match_srcid && match_inst;
-
-            // update the cache directory (for the copies)
-            DirectoryEntry entry;
-            entry.valid	  = true;
-            entry.is_cnt  = r_cleanup_is_cnt.read();
-            entry.dirty	  = r_cleanup_dirty.read();
-            entry.tag	  = r_cleanup_tag.read();
-            entry.lock	  = r_cleanup_lock.read();
-            entry.ptr     = r_cleanup_ptr.read();
-
-            if ( r_cleanup_is_cnt.read() )      // counter mode
-            { 
-                entry.count  = r_cleanup_count.read() -1;
-                entry.owner.srcid   = 0;
+            and (r_cleanup_copy_cache.read() == r_cleanup_pktid.read())
+#endif
+            );
+        bool match_inst    = (r_cleanup_copy_inst.read()  == cleanup_inst);
+        bool match         = match_srcid && match_inst;
+
+        // update the cache directory (for the copies)
+        DirectoryEntry entry;
+        entry.valid   = true;
+        entry.is_cnt  = r_cleanup_is_cnt.read();
+        entry.dirty   = r_cleanup_dirty.read();
+        entry.tag     = r_cleanup_tag.read();
+        entry.lock    = r_cleanup_lock.read();
+        entry.ptr     = r_cleanup_ptr.read();
+
+        if ( r_cleanup_is_cnt.read() )      // counter mode
+        {
+          entry.count  = r_cleanup_count.read() -1;
+          entry.owner.srcid   = 0;
 #if L1_MULTI_CACHE
-                entry.owner.cache_id= 0;
-#endif
-                entry.owner.inst    = 0;
-                // response to the cache 
-                r_cleanup_fsm = CLEANUP_RSP;
-            }
-            else			                    // linked_list mode
-            {                       
-                if ( match )  // hit
-                {
-                    entry.count         = 0; // no more copy
-                    entry.owner.srcid   = 0;
+          entry.owner.cache_id= 0;
+#endif
+          entry.owner.inst    = 0;
+          // response to the cache
+          r_cleanup_fsm = CLEANUP_RSP;
+        }
+        else                          // linked_list mode
+        {
+          if ( match )  // hit
+          {
+            entry.count         = 0; // no more copy
+            entry.owner.srcid   = 0;
 #if L1_MULTI_CACHE
-                    entry.owner.cache_id=0;
-#endif
-                    entry.owner.inst    = 0;
-                    r_cleanup_fsm       = CLEANUP_RSP; 
-                } 
-                else         // miss
-                { 
-                    entry.count          = r_cleanup_count.read();
-                    entry.owner.srcid    = r_cleanup_copy.read();
+            entry.owner.cache_id=0;
+#endif
+            entry.owner.inst    = 0;
+            r_cleanup_fsm       = CLEANUP_RSP;
+          }
+          else         // miss
+          {
+            entry.count          = r_cleanup_count.read();
+            entry.owner.srcid    = r_cleanup_copy.read();
 #if L1_MULTI_CACHE
-                    entry.owner.cache_id = r_cleanup_copy_cache.read();
-#endif
-                    entry.owner.inst     = r_cleanup_copy_inst.read();
-                    r_cleanup_fsm        = CLEANUP_UPT_LOCK;
-                }
-            }
-            m_cache_directory.write(set, way, entry);  
+            entry.owner.cache_id = r_cleanup_copy_cache.read();
+#endif
+            entry.owner.inst     = r_cleanup_copy_inst.read();
+            r_cleanup_fsm        = CLEANUP_UPT_LOCK;
+          }
+        }
+        m_cache_directory.write(set, way, entry);
 
 #if DEBUG_MEMC_CLEANUP
-if( m_debug_cleanup_fsm )
-{
-    std::cout << "  <MEMC " << name() << ".CLEANUP_DIR_WRITE> Update directory:" << std::hex
-              << " line = " << r_cleanup_nline.read() * m_words * 4
-              << " / dir_id = " << entry.owner.srcid
-              << " / dir_ins = " << entry.owner.inst
-              << " / count = " << entry.count
-              << " / is_cnt = " << entry.is_cnt << std::endl;
-}
-#endif
-
-            break;
-        }
-        ///////////////////////
-        case CLEANUP_HEAP_LOCK:	 // two cases are handled in this state:
-                                 // - the matching copy is directly in the directory
-                                 // - the matching copy is the first copy in the heap
-        {
-            if ( r_alloc_heap_fsm.read() == ALLOC_HEAP_CLEANUP )
-            {
-                size_t way              = r_cleanup_way.read();
-                size_t set              = m_y[(vci_addr_t)(r_cleanup_nline.read()*m_words*4)];
-                HeapEntry heap_entry    = m_heap.read(r_cleanup_ptr.read());
-                bool last               = (heap_entry.next == r_cleanup_ptr.read());
-                bool cleanup_inst       = r_cleanup_trdid.read() & 0x1; 
-
-                // match_dir computation
-                bool match_dir_srcid    = (r_cleanup_copy.read() == r_cleanup_srcid.read());
-                bool match_dir_inst     = (r_cleanup_copy_inst.read()  == cleanup_inst);
-                bool match_dir          = match_dir_srcid and match_dir_inst;
+        if( m_debug_cleanup_fsm )
+        {
+          std::cout
+            << "  <MEMC " << name()
+            << ".CLEANUP_DIR_WRITE> Update directory:" << std::hex
+            << " line = " << r_cleanup_nline.read() * m_words * 4
+            << " / dir_id = " << entry.owner.srcid
+            << " / dir_ins = " << entry.owner.inst
+            << " / count = " << entry.count
+            << " / is_cnt = " << entry.is_cnt << std::endl;
+        }
+#endif
+
+        break;
+      }
+      
+      ///////////////////////
+      case CLEANUP_HEAP_REQ:
+      // Get the lock to the HEAP directory
+      {
+        if ( r_alloc_heap_fsm.read() == ALLOC_HEAP_CLEANUP )
+        {
+          r_cleanup_fsm = CLEANUP_HEAP_LOCK;
+        }
+
+#if DEBUG_MEMC_CLEANUP
+        if( m_debug_cleanup_fsm )
+        {
+          std::cout 
+            << "  <MEMC " << name() << ".CLEANUP_HEAP_REQ> Requesting HEAP lock "
+            << std::endl;
+        }
+#endif
+        break;
+      }
+
+      ///////////////////////
+      case CLEANUP_HEAP_LOCK:
+      // two cases are handled in this state:
+      // - the matching copy is directly in the directory
+      // - the matching copy is the first copy in the heap
+      {
+        if ( r_alloc_heap_fsm.read() == ALLOC_HEAP_CLEANUP )
+        {
+          size_t way              = r_cleanup_way.read();
+          size_t set              = m_y[(vci_addr_t)(r_cleanup_nline.read()*m_words*4)];
+          HeapEntry heap_entry    = m_heap.read(r_cleanup_ptr.read());
+          bool last               = (heap_entry.next == r_cleanup_ptr.read());
+          bool cleanup_inst       = r_cleanup_trdid.read() & 0x1;
+
+          // match_dir computation
+          bool match_dir_srcid    = (r_cleanup_copy.read() == r_cleanup_srcid.read());
+          bool match_dir_inst     = (r_cleanup_copy_inst.read()  == cleanup_inst);
+          bool match_dir          = match_dir_srcid and match_dir_inst;
 #if L1_MULTI_CACHE
-                match_dir = match_dir and (r_cleanup_copy_cache.read() == r_cleanup_pktid.read());
-#endif
-
-                // match_heap computation
-                bool match_heap_srcid   = (heap_entry.owner.srcid == r_cleanup_srcid.read());
-                bool match_heap_inst    = (heap_entry.owner.inst  == cleanup_inst);
-                bool match_heap         = match_heap_srcid and match_heap_inst;
+          match_dir = match_dir and (r_cleanup_copy_cache.read() == r_cleanup_pktid.read());
+#endif
+
+          // match_heap computation
+          bool match_heap_srcid   = (heap_entry.owner.srcid == r_cleanup_srcid.read());
+          bool match_heap_inst    = (heap_entry.owner.inst  == cleanup_inst);
+          bool match_heap         = match_heap_srcid and match_heap_inst;
 #if L1_MULTI_CACHE
-                match_heap = match_heap and (heap_entry.owner.cache_id == r_cleanup_pktid.read());
-#endif
-
-                r_cleanup_prev_ptr      = r_cleanup_ptr.read();
-                r_cleanup_prev_srcid    = heap_entry.owner.srcid;
+          match_heap = match_heap and (heap_entry.owner.cache_id == r_cleanup_pktid.read());
+#endif
+
+          r_cleanup_prev_ptr      = r_cleanup_ptr.read();
+          r_cleanup_prev_srcid    = heap_entry.owner.srcid;
 #if L1_MULTI_CACHE
-                r_cleanup_prev_cache_id = heap_entry.owner.cache_id;
-#endif
-                r_cleanup_prev_inst     = heap_entry.owner.inst;
-
-                if (match_dir) // the matching copy is registered in the directory 
-                {       
-                    // the copy registered in the directory must be replaced 
-                    // by the first copy registered in the heap 
-                    // and the corresponding entry must be freed
-                    DirectoryEntry dir_entry;
-                    dir_entry.valid	        = true;
-                    dir_entry.is_cnt        = r_cleanup_is_cnt.read();
-                    dir_entry.dirty	        = r_cleanup_dirty.read();
-                    dir_entry.tag	        = r_cleanup_tag.read();
-                    dir_entry.lock	        = r_cleanup_lock.read();
-                    dir_entry.ptr           = heap_entry.next;
-                    dir_entry.count         = r_cleanup_count.read()-1;
-                    dir_entry.owner.srcid   = heap_entry.owner.srcid;
+          r_cleanup_prev_cache_id = heap_entry.owner.cache_id;
+#endif
+          r_cleanup_prev_inst     = heap_entry.owner.inst;
+
+          if (match_dir)
+          // the matching copy is registered in the directory
+          {
+            // the copy registered in the directory must be replaced
+            // by the first copy registered in the heap
+            // and the corresponding entry must be freed
+            DirectoryEntry dir_entry;
+            dir_entry.valid          = true;
+            dir_entry.is_cnt         = r_cleanup_is_cnt.read();
+            dir_entry.dirty          = r_cleanup_dirty.read();
+            dir_entry.tag            = r_cleanup_tag.read();
+            dir_entry.lock           = r_cleanup_lock.read();
+            dir_entry.ptr            = heap_entry.next;
+            dir_entry.count          = r_cleanup_count.read()-1;
+            dir_entry.owner.srcid    = heap_entry.owner.srcid;
 #if L1_MULTI_CACHE
-                    dir_entry.owner.cache_id = heap_entry.owner.cache_id;
-#endif
-                    dir_entry.owner.inst    = heap_entry.owner.inst;
-                    m_cache_directory.write(set,way,dir_entry);
-                    r_cleanup_next_ptr      = r_cleanup_ptr.read();
-                    r_cleanup_fsm           = CLEANUP_HEAP_FREE;
-                }
-                else if (match_heap) // the matching copy is the first copy in the heap
-                {
-                    // The first copy in heap must be freed
-                    // and the copy registered in directory must point to the next copy in heap
-                    DirectoryEntry dir_entry;
-                    dir_entry.valid	        = true;
-                    dir_entry.is_cnt        = r_cleanup_is_cnt.read();
-                    dir_entry.dirty	        = r_cleanup_dirty.read();
-                    dir_entry.tag	        = r_cleanup_tag.read();
-                    dir_entry.lock	        = r_cleanup_lock.read();
-                    dir_entry.ptr           = heap_entry.next;
-                    dir_entry.count         = r_cleanup_count.read()-1;
-                    dir_entry.owner.srcid   = r_cleanup_copy.read();
+            dir_entry.owner.cache_id = heap_entry.owner.cache_id;
+#endif
+            dir_entry.owner.inst     = heap_entry.owner.inst;
+
+            m_cache_directory.write(set,way,dir_entry);
+
+            r_cleanup_next_ptr       = r_cleanup_ptr.read();
+            r_cleanup_fsm            = CLEANUP_HEAP_FREE;
+          }
+          else if (match_heap)
+          // the matching copy is the first copy in the heap
+          {
+            // The first copy in heap must be freed
+            // and the copy registered in directory must point to the next copy in heap
+            DirectoryEntry dir_entry;
+            dir_entry.valid          = true;
+            dir_entry.is_cnt         = r_cleanup_is_cnt.read();
+            dir_entry.dirty          = r_cleanup_dirty.read();
+            dir_entry.tag            = r_cleanup_tag.read();
+            dir_entry.lock           = r_cleanup_lock.read();
+            dir_entry.ptr            = heap_entry.next;
+            dir_entry.count          = r_cleanup_count.read()-1;
+            dir_entry.owner.srcid    = r_cleanup_copy.read();
 #if L1_MULTI_CACHE
-                    dir_entry.owner.cache_id = r_cleanup_copy_cache.read();
-#endif
-                    dir_entry.owner.inst    = r_cleanup_copy_inst.read();
-                    m_cache_directory.write(set,way,dir_entry);
-                    r_cleanup_next_ptr      = r_cleanup_ptr.read();
-                    r_cleanup_fsm           = CLEANUP_HEAP_FREE;
-                }
-                else if(!last) // The matching copy is in the heap, but is not the first copy
-                {
-                    // The directory entry must be modified to decrement count
-                    DirectoryEntry  dir_entry;
-                    dir_entry.valid	      = true;
-                    dir_entry.is_cnt      = r_cleanup_is_cnt.read();
-                    dir_entry.dirty	      = r_cleanup_dirty.read();
-                    dir_entry.tag	      = r_cleanup_tag.read();
-                    dir_entry.lock        = r_cleanup_lock.read();
-                    dir_entry.ptr         = r_cleanup_ptr.read();
-                    dir_entry.count       = r_cleanup_count.read()-1;
-                    dir_entry.owner.srcid = r_cleanup_copy.read();
+            dir_entry.owner.cache_id = r_cleanup_copy_cache.read();
+#endif
+            dir_entry.owner.inst     = r_cleanup_copy_inst.read();
+
+            m_cache_directory.write(set,way,dir_entry);
+
+            r_cleanup_next_ptr       = r_cleanup_ptr.read();
+            r_cleanup_fsm            = CLEANUP_HEAP_FREE;
+          }
+          else if(!last)
+          // The matching copy is in the heap, but is not the first copy
+          {
+            // The directory entry must be modified to decrement count
+            DirectoryEntry  dir_entry;
+            dir_entry.valid          = true;
+            dir_entry.is_cnt         = r_cleanup_is_cnt.read();
+            dir_entry.dirty          = r_cleanup_dirty.read();
+            dir_entry.tag            = r_cleanup_tag.read();
+            dir_entry.lock           = r_cleanup_lock.read();
+            dir_entry.ptr            = r_cleanup_ptr.read();
+            dir_entry.count          = r_cleanup_count.read()-1;
+            dir_entry.owner.srcid    = r_cleanup_copy.read();
 #if L1_MULTI_CACHE
-                    dir_entry.owner.cache_id = r_cleanup_copy_cache.read();
-#endif
-                    dir_entry.owner.inst     = r_cleanup_copy_inst.read();
-                    m_cache_directory.write(set,way,dir_entry);
-                    r_cleanup_next_ptr       = heap_entry.next;
-                    r_cleanup_fsm            = CLEANUP_HEAP_SEARCH;
-                } 
-                else
-                {
-                    std::cout << "VCI_MEM_CACHE ERROR " << name() 
-                              << " CLEANUP_HEAP_LOCK state"
-                              << " hit but copy not found" << std::endl;
-                    exit(0);
-                }
+            dir_entry.owner.cache_id = r_cleanup_copy_cache.read();
+#endif
+            dir_entry.owner.inst     = r_cleanup_copy_inst.read();
+
+            m_cache_directory.write(set,way,dir_entry);
+
+            r_cleanup_next_ptr       = heap_entry.next;
+            r_cleanup_fsm            = CLEANUP_HEAP_SEARCH;
+          }
+          else
+          {
+            std::cout << "VCI_MEM_CACHE ERROR " << name()
+              << " CLEANUP_HEAP_LOCK state"
+              << " hit but copy not found" << std::endl;
+            exit(0);
+          }
 
 #if DEBUG_MEMC_CLEANUP
-if( m_debug_cleanup_fsm )
-{
-    std::cout << "  <MEMC " << name() << ".CLEANUP_HEAP_LOCK> Checks matching:"
+          if( m_debug_cleanup_fsm )
+          {
+            std::cout
+              << "  <MEMC " << name() << ".CLEANUP_HEAP_LOCK> Checks matching:"
               << " line = " << r_cleanup_nline.read() * m_words * 4
               << " / dir_id = " << r_cleanup_copy.read()
               << " / dir_ins = " << r_cleanup_copy_inst.read()
               << " / heap_id = " << heap_entry.owner.srcid
-              << " / heap_ins = " << heap_entry.owner.inst 
-              << " / search_id = " << r_cleanup_srcid.read() 
-              << " / search_ins = " << (r_cleanup_trdid.read()&0x1) << std::endl;
-}
-#endif
-            }
-            break;
-        }
-        /////////////////////////
-        case CLEANUP_HEAP_SEARCH:  // This state is handling the case where the copy
-                                   // is in the heap, but is not the first in the linked list
-        {
-            if ( r_alloc_heap_fsm.read() != ALLOC_HEAP_CLEANUP )
-            {
-                std::cout << "VCI_MEM_CACHE ERROR " << name() 
-                          << " CLEANUP_HEAP_SEARCH state" 
-                          << " bad HEAP allocation" << std::endl;
-                exit(0);
-            }
-
-            HeapEntry heap_entry  = m_heap.read(r_cleanup_next_ptr.read());
-            bool last             = (heap_entry.next == r_cleanup_next_ptr.read());
-            bool cleanup_inst     = r_cleanup_trdid.read() & 0x1; 
-            bool match_heap_srcid = (heap_entry.owner.srcid == r_cleanup_srcid.read());
-            bool match_heap_inst  = (heap_entry.owner.inst  == cleanup_inst);
-            bool match_heap       = match_heap_srcid && match_heap_inst;
-#if L1_MULTI_CACHE
-            match_heap = match_heap and (heap_entry.owner.cache_id == r_cleanup_pktid.read());
-#endif
-
-#if DEBUG_MEMC_CLEANUP
-if( m_debug_cleanup_fsm )
-{
-    std::cout << "  <MEMC " << name() << ".CLEANUP_HEAP_SEARCH> Cheks matching:"
-              << " line = " << r_cleanup_nline.read() * m_words * 4
-              << " / heap_id = " << heap_entry.owner.srcid
-              << " / heap_ins = " << heap_entry.owner.inst
-              << " / search_id = " << r_cleanup_srcid.read()
-              << " / search_ins = " << (r_cleanup_trdid.read()&0x1) 
-              << " / last = " << last << std::endl;
-}
-#endif
-            if(match_heap) // the matching copy must be removed
-            {
-                r_cleanup_ptr = heap_entry.next; // reuse ressources
-                r_cleanup_fsm = CLEANUP_HEAP_CLEAN;
-            }
-            else
-            {
-                if ( last ) 
-                {
-                    std::cout << "VCI_MEM_CACHE_ERROR " << name() 
-                              << " CLEANUP_HEAP_SEARCH state" 
-                              << " cleanup hit but copy not found" << std::endl;
-                    exit(0);
-                } 
-                else // test the next in the linked list
-                {
-                    r_cleanup_prev_ptr      = r_cleanup_next_ptr.read();
-                    r_cleanup_prev_srcid    = heap_entry.owner.srcid;
-#if L1_MULTI_CACHE
-                    r_cleanup_prev_cache_id = heap_entry.owner.cache_id;
-#endif
-                    r_cleanup_prev_inst     = heap_entry.owner.inst;
-                    r_cleanup_next_ptr      = heap_entry.next;
-                    r_cleanup_fsm           = CLEANUP_HEAP_SEARCH;
-
-#if DEBUG_MEMC_CLEANUP
-if( m_debug_cleanup_fsm )
-{
-    std::cout << "  <MEMC " << name() << ".CLEANUP_HEAP_SEARCH> Matching copy not found, search next:"
-              << " line = " << r_cleanup_nline.read() * m_words * 4
-              << " / heap_id = " << heap_entry.owner.srcid
               << " / heap_ins = " << heap_entry.owner.inst
               << " / search_id = " << r_cleanup_srcid.read()
               << " / search_ins = " << (r_cleanup_trdid.read()&0x1) << std::endl;
-}
-#endif
-                }
-            }
-            break;
-        }
-        ////////////////////////
-        case CLEANUP_HEAP_CLEAN:  // remove a copy in the linked list
-        {
-            if ( r_alloc_heap_fsm.read() != ALLOC_HEAP_CLEANUP )
-            {
-                std::cout << "VCI_MEM_CACHE ERROR " << name() 
-                          << " CLEANUP_HEAP_CLEAN state"
-                          << "Bad HEAP allocation" << std::endl;
-                exit(0);
-            }
-
-            bool last = (r_cleanup_next_ptr.read() == r_cleanup_ptr.read());
-            HeapEntry heap_entry; 
-            heap_entry.owner.srcid    = r_cleanup_prev_srcid.read();
+          }
+#endif
+        }
+        else
+        {
+          std::cout << "VCI_MEM_CACHE ERROR " << name()
+            << " CLEANUP_HEAP_LOCK state"
+            << " bad HEAP allocation" << std::endl;
+
+          exit(0);
+        }
+        break;
+      }
+
+      /////////////////////////
+      case CLEANUP_HEAP_SEARCH:  // This state is handling the case where the copy
+      // is in the heap, but is not the first in the linked list
+      {
+        if ( r_alloc_heap_fsm.read() != ALLOC_HEAP_CLEANUP )
+        {
+          std::cout << "VCI_MEM_CACHE ERROR " << name()
+            << " CLEANUP_HEAP_SEARCH state"
+            << " bad HEAP allocation" << std::endl;
+          exit(0);
+        }
+
+        HeapEntry heap_entry  = m_heap.read(r_cleanup_next_ptr.read());
+        bool last             = (heap_entry.next == r_cleanup_next_ptr.read());
+        bool cleanup_inst     = r_cleanup_trdid.read() & 0x1;
+        bool match_heap_srcid = (heap_entry.owner.srcid == r_cleanup_srcid.read());
+        bool match_heap_inst  = (heap_entry.owner.inst  == cleanup_inst);
+        bool match_heap       = match_heap_srcid && match_heap_inst;
 #if L1_MULTI_CACHE
-            heap_entry.owner.cache_id = r_cleanup_prev_cache_id.read();
-#endif
-            heap_entry.owner.inst     = r_cleanup_prev_inst.read();
-            if(last) // this is the last entry of the list of copies
-            {
-                heap_entry.next     = r_cleanup_prev_ptr.read();
-            } 
-            else  // this is not the last entry
-            {
-                heap_entry.next     = r_cleanup_ptr.read();
-            }
-            m_heap.write(r_cleanup_prev_ptr.read(),heap_entry);
-            r_cleanup_fsm = CLEANUP_HEAP_FREE;
+        match_heap = match_heap and (heap_entry.owner.cache_id == r_cleanup_pktid.read());
+#endif
 
 #if DEBUG_MEMC_CLEANUP
-if( m_debug_cleanup_fsm )
-{
-    std::cout << "  <MEMC " << name() << ".CLEANUP_HEAP_SEARCH> Remove the copy in the linked list" << std::endl;
-}
-#endif
-            break;
-        }
-        ///////////////////////
-        case CLEANUP_HEAP_FREE:  // The heap entry pointed by r_cleanup_next_ptr is freed
-                                 // and becomes the head of the list of free entries
-        {
-            if ( r_alloc_heap_fsm.read() != ALLOC_HEAP_CLEANUP )
-            {
-                std::cout << "VCI_MEM_CACHE ERROR " << name() << " CLEANUP_HEAP_CLEAN state" << std::endl;
-                std::cout << "Bad HEAP allocation" << std::endl;
-                exit(0);
-            }
-
-            HeapEntry heap_entry;
-            heap_entry.owner.srcid    = 0;
+        if( m_debug_cleanup_fsm )
+        {
+          std::cout << "  <MEMC " << name() << ".CLEANUP_HEAP_SEARCH> Cheks matching:"
+            << " line = " << r_cleanup_nline.read() * m_words * 4
+            << " / heap_id = " << heap_entry.owner.srcid
+            << " / heap_ins = " << heap_entry.owner.inst
+            << " / search_id = " << r_cleanup_srcid.read()
+            << " / search_ins = " << (r_cleanup_trdid.read()&0x1)
+            << " / last = " << last << std::endl;
+        }
+#endif
+        if(match_heap) // the matching copy must be removed
+        {
+          r_cleanup_ptr = heap_entry.next; // reuse ressources
+          r_cleanup_fsm = CLEANUP_HEAP_CLEAN;
+        }
+        else
+        {
+          if ( last )
+          {
+            std::cout << "VCI_MEM_CACHE_ERROR " << name()
+              << " CLEANUP_HEAP_SEARCH state"
+              << " cleanup hit but copy not found" << std::endl;
+            exit(0);
+          }
+          else // test the next in the linked list
+          {
+            r_cleanup_prev_ptr      = r_cleanup_next_ptr.read();
+            r_cleanup_prev_srcid    = heap_entry.owner.srcid;
 #if L1_MULTI_CACHE
-            heap_entry.owner.cache_id = 0;
-#endif
-            heap_entry.owner.inst     = false;
-
-            if(m_heap.is_full()) heap_entry.next     = r_cleanup_next_ptr.read();
-            else                           heap_entry.next     = m_heap.next_free_ptr();
-            m_heap.write(r_cleanup_next_ptr.read(),heap_entry);
-            m_heap.write_free_ptr(r_cleanup_next_ptr.read());
-            m_heap.unset_full();
+            r_cleanup_prev_cache_id = heap_entry.owner.cache_id;
+#endif
+            r_cleanup_prev_inst     = heap_entry.owner.inst;
+            r_cleanup_next_ptr      = heap_entry.next;
+            r_cleanup_fsm           = CLEANUP_HEAP_SEARCH;
+
+#if DEBUG_MEMC_CLEANUP
+            if( m_debug_cleanup_fsm )
+            {
+              std::cout << "  <MEMC " << name() << ".CLEANUP_HEAP_SEARCH> Matching copy not found, search next:"
+                << " line = " << r_cleanup_nline.read() * m_words * 4
+                << " / heap_id = " << heap_entry.owner.srcid
+                << " / heap_ins = " << heap_entry.owner.inst
+                << " / search_id = " << r_cleanup_srcid.read()
+                << " / search_ins = " << (r_cleanup_trdid.read()&0x1) << std::endl;
+            }
+#endif
+          }
+        }
+        break;
+      }
+
+      ////////////////////////
+      case CLEANUP_HEAP_CLEAN:  // remove a copy in the linked list
+      {
+        if ( r_alloc_heap_fsm.read() != ALLOC_HEAP_CLEANUP )
+        {
+          std::cout << "VCI_MEM_CACHE ERROR " << name()
+            << " CLEANUP_HEAP_CLEAN state"
+            << "Bad HEAP allocation" << std::endl;
+          exit(0);
+        }
+
+        bool last = (r_cleanup_next_ptr.read() == r_cleanup_ptr.read());
+        HeapEntry heap_entry;
+        heap_entry.owner.srcid    = r_cleanup_prev_srcid.read();
+#if L1_MULTI_CACHE
+        heap_entry.owner.cache_id = r_cleanup_prev_cache_id.read();
+#endif
+        heap_entry.owner.inst     = r_cleanup_prev_inst.read();
+        
+        if(last) // this is the last entry of the list of copies
+        {
+          heap_entry.next     = r_cleanup_prev_ptr.read();
+        }
+        else  // this is not the last entry
+        {
+          heap_entry.next     = r_cleanup_ptr.read();
+        }
+
+        m_heap.write(r_cleanup_prev_ptr.read(),heap_entry);
+        r_cleanup_fsm = CLEANUP_HEAP_FREE;
+
+#if DEBUG_MEMC_CLEANUP
+        if( m_debug_cleanup_fsm )
+        {
+          std::cout << "  <MEMC " << name() << ".CLEANUP_HEAP_SEARCH> Remove the copy in the linked list" << std::endl;
+        }
+#endif
+        break;
+      }
+
+      ///////////////////////
+      case CLEANUP_HEAP_FREE:
+      // The heap entry pointed by r_cleanup_next_ptr is freed
+      // and becomes the head of the list of free entries
+      {
+        if ( r_alloc_heap_fsm.read() != ALLOC_HEAP_CLEANUP )
+        {
+          std::cout 
+            << "VCI_MEM_CACHE ERROR " << name()
+            << " CLEANUP_HEAP_CLEAN state" << std::endl
+            << "Bad HEAP allocation" << std::endl;
+
+          exit(0);
+        }
+
+        HeapEntry heap_entry;
+        heap_entry.owner.srcid    = 0;
+#if L1_MULTI_CACHE
+        heap_entry.owner.cache_id = 0;
+#endif
+        heap_entry.owner.inst     = false;
+
+        if(m_heap.is_full())
+        {
+          heap_entry.next = r_cleanup_next_ptr.read();
+        }
+        else
+        {
+          heap_entry.next = m_heap.next_free_ptr();
+        }
+
+        m_heap.write(r_cleanup_next_ptr.read(),heap_entry);
+        m_heap.write_free_ptr(r_cleanup_next_ptr.read());
+        m_heap.unset_full();
+
+        r_cleanup_fsm = CLEANUP_RSP;
+
+#if DEBUG_MEMC_CLEANUP
+        if( m_debug_cleanup_fsm )
+        {
+          std::cout << "  <MEMC " << name() << ".CLEANUP_HEAP_SEARCH> Update the list of free entries" << std::endl;
+        }
+#endif
+        break;
+      }
+
+      //////////////////////
+      case CLEANUP_UPT_LOCK:
+      {
+        if ( r_alloc_upt_fsm.read() == ALLOC_UPT_CLEANUP )
+        {
+          size_t index = 0;
+          bool hit_inval;
+          hit_inval = m_update_tab.search_inval(r_cleanup_nline.read(),index);
+
+          if ( !hit_inval ) // no pending inval
+          {
+
+#if DEBUG_MEMC_CLEANUP
+            if( m_debug_cleanup_fsm )
+            {
+              std::cout << "  <MEMC " << name() << ".CLEANUP_UPT_LOCK> Unexpected cleanup with no corresponding UPT entry:"
+                << " address = " << std::hex << (r_cleanup_nline.read()*4*m_words) << std::endl;
+            }
+#endif
             r_cleanup_fsm = CLEANUP_RSP;
+          }
+          else    // pending inval
+          {
+            r_cleanup_write_srcid = m_update_tab.srcid(index);
+            r_cleanup_write_trdid = m_update_tab.trdid(index);
+            r_cleanup_write_pktid = m_update_tab.pktid(index);
+            r_cleanup_need_rsp    = m_update_tab.need_rsp(index);
+            r_cleanup_fsm = CLEANUP_UPT_WRITE;
+          }
+          r_cleanup_index.write(index) ;
+        }
+        break;
+      }
+
+      ///////////////////////
+      case CLEANUP_UPT_WRITE:  // decrement response counter
+      {
+        size_t count = 0;
+        m_update_tab.decrement(r_cleanup_index.read(), count);
+        if ( count == 0 )
+        {
+          m_update_tab.clear(r_cleanup_index.read());
 
 #if DEBUG_MEMC_CLEANUP
-if( m_debug_cleanup_fsm )
-{
-    std::cout << "  <MEMC " << name() << ".CLEANUP_HEAP_SEARCH> Update the list of free entries" << std::endl;
-}
-#endif
-            break;
-        }
-        //////////////////////
-        case CLEANUP_UPT_LOCK:
-        {
-            if ( r_alloc_upt_fsm.read() == ALLOC_UPT_CLEANUP )
-            {
-                size_t index = 0;
-                bool hit_inval;
-                hit_inval = m_update_tab.search_inval(r_cleanup_nline.read(),index);
-
-                if ( !hit_inval ) // no pending inval
-                {
-
-#if DEBUG_MEMC_CLEANUP
-if( m_debug_cleanup_fsm )
-{
-    std::cout << "  <MEMC " << name() << ".CLEANUP_UPT_LOCK> Unexpected cleanup with no corresponding UPT entry:"
-              << " address = " << std::hex << (r_cleanup_nline.read()*4*m_words) << std::endl;
-}
-#endif
-                    r_cleanup_fsm = CLEANUP_RSP;
-                } 
-                else		// pending inval 
-                {
-                    r_cleanup_write_srcid = m_update_tab.srcid(index);
-                    r_cleanup_write_trdid = m_update_tab.trdid(index);
-                    r_cleanup_write_pktid = m_update_tab.pktid(index);
-                    r_cleanup_need_rsp    = m_update_tab.need_rsp(index);
-                    r_cleanup_fsm = CLEANUP_UPT_WRITE;
-                }
-                r_cleanup_index.write(index) ; 
-            }
-            break;
-        }
-        ///////////////////////
-        case CLEANUP_UPT_WRITE:  // decrement response counter
-        {
-            size_t count = 0;
-            m_update_tab.decrement(r_cleanup_index.read(), count);
-            if ( count == 0 )
-            {
-                m_update_tab.clear(r_cleanup_index.read());
-
-#if DEBUG_MEMC_CLEANUP
-if( m_debug_cleanup_fsm )
-{
-    std::cout << "  <MEMC " << name() << ".CLEANUP_UPT_WRITE> Decrement response counter in UPT:"
+          if( m_debug_cleanup_fsm )
+          {
+            std::cout << "  <MEMC " << name() << ".CLEANUP_UPT_WRITE> Decrement response counter in UPT:"
               << " UPT_index = " << r_cleanup_index.read()
               << " rsp_count = " << count << std::endl;
-}
-#endif
-                if( r_cleanup_need_rsp.read() ) r_cleanup_fsm = CLEANUP_WRITE_RSP ;  
-                else  				            r_cleanup_fsm = CLEANUP_RSP;
-            } 
-            else 
-            {
-                r_cleanup_fsm = CLEANUP_RSP ;
-            }
-            break;
-        }
-        ///////////////////////
-        case CLEANUP_WRITE_RSP:	// Response to a previous write on the direct network
-        {
-            if( !r_cleanup_to_tgt_rsp_req.read() ) 
-            {
-                r_cleanup_to_tgt_rsp_req     = true;
-                r_cleanup_to_tgt_rsp_srcid   = r_cleanup_write_srcid.read();
-                r_cleanup_to_tgt_rsp_trdid   = r_cleanup_write_trdid.read();
-                r_cleanup_to_tgt_rsp_pktid   = r_cleanup_write_pktid.read();
-                r_cleanup_fsm                = CLEANUP_RSP;
+          }
+#endif
+          if( r_cleanup_need_rsp.read() ) r_cleanup_fsm = CLEANUP_WRITE_RSP ;
+          else                      r_cleanup_fsm = CLEANUP_RSP;
+        }
+        else
+        {
+          r_cleanup_fsm = CLEANUP_RSP ;
+        }
+        break;
+      }
+
+      ///////////////////////
+      case CLEANUP_WRITE_RSP: // Response to a previous write on the direct network
+      {
+        if( !r_cleanup_to_tgt_rsp_req.read() )
+        {
+          r_cleanup_to_tgt_rsp_req     = true;
+          r_cleanup_to_tgt_rsp_srcid   = r_cleanup_write_srcid.read();
+          r_cleanup_to_tgt_rsp_trdid   = r_cleanup_write_trdid.read();
+          r_cleanup_to_tgt_rsp_pktid   = r_cleanup_write_pktid.read();
+          r_cleanup_fsm                = CLEANUP_RSP;
 
 #if DEBUG_MEMC_CLEANUP
-if( m_debug_cleanup_fsm )
-{
-    std::cout << "  <MEMC " << name() << ".CLEANUP_WRITE_RSP> Send a response to a cleanup request:"
+          if( m_debug_cleanup_fsm )
+          {
+            std::cout << "  <MEMC " << name() << ".CLEANUP_WRITE_RSP> Send a response to a cleanup request:"
               << " rsrcid = " << std::dec << r_cleanup_write_srcid.read()
               << " / rtrdid = " << std::dec << r_cleanup_write_trdid.read() << std::endl;
-}
-#endif
-            }
-            break;
-        }
-        /////////////////
-        case CLEANUP_RSP:	// Response to a cleanup on the coherence network
-        {
-            if ( p_vci_tgt_cleanup.rspack.read() ) 
-            {
-                r_cleanup_fsm = CLEANUP_IDLE;
+          }
+#endif
+        }
+        break;
+      }
+
+      /////////////////
+      case CLEANUP_RSP: // Response to a cleanup on the coherence network
+      {
+        if ( p_vci_tgt_cleanup.rspack.read() )
+        {
+          r_cleanup_fsm = CLEANUP_IDLE;
 
 #if DEBUG_MEMC_CLEANUP
-if( m_debug_cleanup_fsm )
-{
-    std::cout << "  <MEMC " << name() << ".CLEANUP_RSP> Send the response to a cleanup request:"
+          if( m_debug_cleanup_fsm )
+          {
+            std::cout << "  <MEMC " << name() << ".CLEANUP_RSP> Send the response to a cleanup request:"
               << " rsrcid = " << std::dec << r_cleanup_write_srcid.read()
               << " / rtrdid = " << r_cleanup_write_trdid.read() << std::endl;
-}
-#endif
-            }
-            break;
-        }
+          }
+#endif
+        }
+        break;
+      }
     } // end switch cleanup fsm
 
     ////////////////////////////////////////////////////////////////////////////////////
-    //		SC FSM
+    //    SC FSM
     ////////////////////////////////////////////////////////////////////////////////////
-    // The SC FSM handles the SC (Store Conditionnal) atomic commands, 
+    // The SC FSM handles the SC (Store Conditionnal) atomic commands,
     // that are handled as "compare-and-swap instructions.
-    // 
-    // This command contains two or four flits: 
+    //
+    // This command contains two or four flits:
     // - In case of 32 bits atomic access, the first flit contains the value read
     // by a previous LL instruction, the second flit contains the value to be writen.
     // - In case of 64 bits atomic access, the 2 first flits contains the value read
     // by a previous LL instruction, the 2 next flits contains the value to be writen.
-    // 
+    //
     // The target address is cachable. If it is replicated in other L1 caches
     // than the writer, a coherence operation is done.
-    // 
+    //
     // It access the directory to check hit / miss.
     // - In case of miss, the SC FSM must register a GET transaction in TRT.
-    // If a read transaction to the XRAM for this line already exists, 
+    // If a read transaction to the XRAM for this line already exists,
     // or if the transaction table is full, it goes to the WAIT state
     // to release the locks and try again. When the GET transaction has been
